/* $Id$ */
/* $Date$ */
#include <unistd.h>
/* #include <stdinc.h> */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define BUFFSIZ  (4096)
#define PrintUsage  {fprintf(stderr, "Usage: %s sizeof_file[k/m/g] file_name\n", argv[0]);}

/* ARGSUSED */
int main(int argc, char *argv[])
{
    char  buf[BUFFSIZ];
    int   siz, n, len;
    char  *fname;
    FILE  *fp;

    if (argc < 3) {
        PrintUsage;
        exit(1);
    }
    len = strlen(argv[1]);
    switch (argv[1][len-1]) {
      case 'k':
      case 'K':
        siz = 1024;
        argv[1][len-1] = '\0';
        break;
      case 'm':
      case 'M':
        siz = 1024 * 1024;
        argv[1][len-1] = '\0';
        break;
      case 'g':
      case 'G':
        siz = 1024 * 1024 * 1024;
        argv[1][len-1] = '\0';
        break;
      default:
        siz = 1;
    }
    siz *= atoi(argv[1]);
    fname = argv[2];

    memset(buf, 0, BUFFSIZ);
    fp = fopen(fname, "w");
    if (!fp) {
        perror("fopen");
        exit(1);
    }
    for (; siz >= BUFFSIZ; siz -= BUFFSIZ) {
        n = fwrite(buf, BUFFSIZ, 1, fp);
        if (n < 1) {
            perror("fwrite");
            exit(1);
        }
    }
    n = fwrite(buf, siz, 1, fp);
    if (n < 1) perror("fwrite");
    
    fclose(fp);
    exit(0);
}

